#DEFINE EXCEPTION_STARTPROFILE	0x8F000001
#DEFINE EXCEPTION_ENDPROFILE	0x8F000002
#DEFINE EXCEPTION_QUITPROFILE	0x8F000003

ExceptionArgs STRUCT
	Name	CHAR 28 DUP
	type	DWORD32
ENDS

NewProfile(%Name) MACRO
	#IFDEF PROFILE_ON
	#IFNDEF ExceptionArgs1
		DATA SECTION
		ExceptionArgs1 ExceptionArgs <>
		CODE SECTION
	#ENDIF
	push 27
	push %Name
	push offset ExceptionArgs1
	call lstrcpynA
	mov D[ExceptionArgs1.type],EXCEPTION_STARTPROFILE
	push offset ExceptionArgs1
	int3
	#ENDIF
ENDM

EndProfile MACRO
	#IFDEF PROFILE_ON
	#IFNDEF ExceptionArgs1
		DATA SECTION
		ExceptionArgs1 ExceptionArgs <>
		CODE SECTION
	#ENDIF
	mov D[ExceptionArgs1.type],EXCEPTION_ENDPROFILE
	push offset ExceptionArgs1
	int3
	#ENDIF
ENDM

ExitProfile MACRO // Not yet implemented
	#IFDEF PROFILE_ON
	#IFNDEF ExceptionArgs1
		DATA SECTION
		ExceptionArgs1 ExceptionArgs <>
		CODE SECTION
	#ENDIF
	mov D[ExceptionArgs1.type],EXCEPTION_QUITPROFILE
	push offset ExceptionArgs1
	int3
	#ENDIF
ENDM
